__doc__ = """\
Project:RequestDecoder
: Tue Dec 18 12:38:16 MSK 2001
Author: Andrey Orlov (c) 2001
Version:$Id: RequestDecoder.py,v 1.12 2003/01/12 16:36:01 cray Exp $

Title:
        Request Decoder / Class definitions

Description:

        Request Decoder are analyze all request and try to guess right
        encoding of text fields. If encoding are guessed then request 
        fields will be decoded into one.

        For additional info see the help.        

Features:
            "" - 
              .  
          ,      
        .

License :
        GPL
    
Warranty:
        There is no warranty of any kind, either expressed or implied
                    
TODO:
        + Request Logging
        
        + Use with any russian encodings

"""
__version__ = '$Revision: 1.12 $'[8:-1]

from Globals import HTMLFile      
from Globals import MessageDialog 
from Globals import Persistent    
from Globals import default__class_init__

import OFS.SimpleItem
import Acquisition
import uncensored

from zLOG import LOG, INFO, DEBUG, TRACE

def _(x) : return x
                                                
try :
    from Products.MOFS.PropertyManager import PropertyManager
except ImportError :
    LOG("RequestDecoder",INFO,_("Standard OFS will be used because of MOFS components not found"))
    from OFS.PropertyManager import PropertyManager
        
def debug(x) :
    LOG("RequestDecoder",TRACE,x)

import AccessControl.Role
import Products
import decoder
decoder.debug = debug
from decoder import recode, default_target_encoding
from Products.SiteAccess.SiteRoot import Traverser

import re,string

manage_addRequestDecoderForm = HTMLFile('dtml/RequestDecoderAdd', globals()) 

def manage_addRequestDecoder(self, id, title=None, REQUEST=None):
    """ Add RequestDecoder """
    ob = RequestDecoder(id)
    self._setObject(id, ob)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

def ifret(cond,s1,s2) :
        if cond :
                return s1
        else :
                return s2

Uncensored = 'Uncensored'

class RequestDecoder(
    Traverser,
    PropertyManager,
    OFS.SimpleItem.Item,   
    Persistent,                Acquisition.Implicit,  
    AccessControl.Role.RoleManager 
    ): 
    """ 

      :     ,  
         :

    1.      ;

    2.         ;
  
          ,   
     .

           , 
    ,     ,   ,
       .    ,
     .

         .
    """
        
    meta_type = 'RequestDecoder' 

    manage_options = PropertyManager.manage_options + ( 
        {'label': '',                       'action': 'manage_test_form',   'help':('RequestDecoder','RequestDecoder_Properties.stx')}, 
#       {'label': '',                  'action': 'manage_tunning'}, 
#       {'label': 'Regexp',                     'action': 'manage_regexp'}, 
#       {'label': 'Paths',                      'action': 'manage_paths'}, 
    ) 

    use_decoder = ''
    use_post_always = ''
    use_encode_vars = ''
    use_regexp_paths = 'on'
    use_censor = ''
    min_size = 4
    check_text = '[^A-Za-z]{5,}'
    request_form_name = 'autoencode'
    request_cookie_name = 'autoencode'
    censor_type = 'Fast' #uncensored.censor_list[0]
    censor_list = uncensored.censor_list
    target_encoding = ''#default_target_encoding

    _properties = PropertyManager._properties + (
        {'id':'use_censor',         'name':_(' '),                       'type':'boolean',   'mode':'w'},
        {'id':'censor_type',        'name':_(' '),                            'type':'selection', 'mode':'w',     'select_variable':'censor_list' },
        {'id':'use_decoder',        'name':_(''),                               'type':'boolean',   'mode':'w'},
        {'id':'use_post_always',    'name':_('   Post'),        'type':'boolean',   'mode':'w'},
        {'id':'min_size',           'name':_('   '),'type':'int',       'mode':'w'},
        {'id':'check_text',         'name':_('   '),             'type':'string',    'mode':'w'},
        {'id':'request_form_name',  'name':_(' '),                  'type':'string',    'mode':'w'},
        {'id':'request_cookie_name','name':_(' '),                   'type':'string',    'mode':'w'},
        {'id':'use_encode_vars',    'name':_('   '),'type':'boolean',  'mode':'w'},
        {'id':'encode_vars',        'name':_(' '),                   'type':'tokens',    'mode':'w'},
        {'id':'use_regexp_paths',   'name':_('   '),     'type':'boolean',   'mode':'w'},
        {'id':'regexp',             'name':_(' '),                   'type':'lines',     'mode':'w'},
        {'id':'paths',              'name':_(''),                                   'type':'lines',     'mode':'w'},
        {'id':'target_encoding',    'name':_(' '),                      'type':'selection', 'mode':'w',     'select_variable':'encodings_list'}
    )

    encodings_list = (('',_('Use Locale (%s)') % default_target_encoding),('KOI8-R',_('Unix KOI8')),('CP1251','Windows CP1251'))
    encodings_list = ((_('Use Locale (%s)') % default_target_encoding,''),(_('Unix KOI8'),'KOI8-R'),(_('Windows CP1251'),'CP1251'))
    encodings_list = ('','KOI8-R','CP1251')

    def __init__(self, id, title='') :  
        """initialise a new instance of RequestDecoder"""
        self.id = id
        self.title = title
        self.regexp = ['/manage[^/]*']
        self.paths  = []
        self.encode_vars = []

    manage_test_form = HTMLFile('dtml/RequestDecoderTest', globals()) 
    _request_decoder_turn_form = HTMLFile('dtml/RequestDecoderTurn', globals()) 

    def manage_editProperties(self, REQUEST=None, **kw) :
        """ Edit properties """
        try :
                res = apply(PropertyManager.manage_editProperties,(self,REQUEST),kw)
        finally :
                self.compile()
        return res

    def compile(self) :
        self._v_srch = re.compile(self.check_text)
        regexp = filter(lambda x : string.strip(x),self.regexp)
        if len(regexp) :
                self._v_regexp = re.compile('('+string.join(regexp,'|')+')').search
        else :
                self._v_regexp = lambda x : None
        self._v_paths = reduce(lambda x,y : x.update({y:1}) or x , self.paths,{}).has_key

    def request_decoder_turn_form(self,client=None,REQUEST=None,RESPONSE=None,use_short=0) :
        return self._request_decoder_turn_form(self,REQUEST=self.REQUEST,use_short=use_short)

    def manage_tunning(self,REQUEST=None) :
        """   """
        pass

    def manage_regexp(self, REQUEST=None) :
        """ Edit regular expressions list """
        pass

    def autoencode_active(self,set=None) :
        if self.REQUEST.form.has_key(self.request_form_name) :
                return self.REQUEST.form[self.request_form_name] 
        elif self.REQUEST.cookies.has_key(self.request_cookie_name)  :
                return self.REQUEST.cookies[self.request_cookie_name]
        elif self.REQUEST['REQUEST_METHOD'] == 'POST' and self.use_post_always :
                return 1
        else :
                return self.use_decoder

    def manage_paths(self) :
        """ Edit list of catalog """
        pass

    def __call__(self,client,REQUEST,RESPONSE=None) :
        #       Check request to find right encoding
        if self.REQUEST.form.has_key(self.request_form_name) :
            self.REQUEST.RESPONSE.setCookie(self.request_cookie_name,self.REQUEST.form[self.request_form_name],path='/')
        if self.autoencode_active() :
            path = self.REQUEST['PATH_TRANSLATED']
            try :
                res = self._v_regexp(path) or self._v_paths(path)
            except AttributeError :
                self.compile()
                res = self._v_regexp(path) or self._v_paths(path)

            if res :
                res = 1
            else :
                res = 0

            if (self.use_regexp_paths != '') == res :
                for key in REQUEST.form.keys() :
                    if (self.use_encode_vars != '') == (key in self.encode_vars) :
                        LOG('RequestDecoder',DEBUG,'Input key: "%s"' % key)
                        if type(REQUEST.form[key]) in (type([]),type(())) :
                            val = []
                            for item in REQUEST.form[key] :
                                val.append(self.autoencode_item(item))
                    
                            REQUEST.form[key] = val
                            REQUEST[key] = val
                        else :
                            REQUEST.form[key] = self.autoencode_item(REQUEST.form[key])
                            REQUEST[key] = REQUEST.form[key]

    def autoencode_item(self,item) :
        if type(item) == type('') :
                LOG('RequestDecoder',DEBUG,'Input value: "%s"' % item)
                try :
                        test = reduce(lambda x,y : ifret(len(x)>len(y),x,y),self._v_srch.findall(item),'')
                except AttributeError :
                        self._v_srch = re.compile(self.check_text)
                        test = reduce(lambda x,y : ifret(len(x)>len(y),x,y),self._v_srch.findall(item),'')

                test = test[0:min(len(test),64)]

                if len(test) > self.min_size :
                        item = recode(item,test,self.target_encoding or default_target_encoding)
                        LOG('RequestDecoder',DEBUG,'Encoded item: "%s"' % item)
                lex = uncensored.censors[self.censor_type](item)

                if lex :
                        raise Uncensored,_('   "%s",   ') % (lex.group(0))

        return item

default__class_init__ (RequestDecoder)
