#! /usr/bin/python
__doc__ = """\
Project:RequestDecoder
Start:  Tue Dec 18 12:38:16 MSK 2001
Author: Andrey Orlov (c) 2001
Version:$Id: decoder.py,v 1.7 2002/12/02 14:04:37 cray Exp $

Title:
        Request Decoder / n-gram analysis and encoding

Description:

         ,    
        ,     
        .     -
        KOI8-RU.       
         - ,   
             .

Features:
        Script decoder.py can be used as console application for automatic decoder,
        switches :

        -h      - help
        -v      - trace
        -f      - input code table
        -t      - output code table (locale code table is default)
        -m      - do MS like line endings
        
License :
        GPL

Warranty:
        There is no warranty of any kind, either expressed or implied
                    
TODO:
        + Use ALT866, ISO and other russian encodings (This feature is
          implemented but one is not tested yet)
        
"""
__version__ = '$Revision: 1.7 $'[8:-1]


import re,string,time,os,codecs,locale,sys

SOURCE_ENCODINGS = 'koi8-r'

def _(x) : return x

                
if __name__ == '__main__' :
        locale.setlocale(0,os.environ.get('LC_ALL',os.environ.get('LC_CTYPE','ru_RU.KOI8-R')))
        decode_debug = 0
else :
        decode_debug = 0

def debug(x) :
    if decode_debug :
        print x

default_target_encoding = locale.getlocale()[1]
debug(default_target_encoding)

try:
    codecs.lookup(default_target_encoding)
except (LookupError, SystemError):
    LOG("RequestDecoder",INFO,_("Using of default encoding are not possible because %s encoding not found") % default_target_encoding)

srch = re.compile('[^A-Za-z]{5,}')

#  n-
sample = dict(map(lambda (x,y) : (x.decode(SOURCE_ENCODINGS).lower(),y),{ '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,'':1,
    '':1,'':1,'':1,'':1,'':1,'':1,'':1 }.items()))

encode_paths = (
    ('CP1251',), ('KOI8-R',), ('CP866',),
    (('CP1251','KOI8-R'),'CP1251'),
    (('KOI8-R','CP1251'),'KOI8-R'),
    (('CP1251','KOI8-R'),('CP1251','KOI8-R'),'CP1251'),
    (('KOI8-R','CP1251'),('KOI8-R','CP1251'),'KOI8-R'),
    (('CP1251','CP866'),'CP1251'),
    (('KOI8-R','CP866'),'KOI8-R'),
    (('CP866','KOI8-R'),'CP866'),
    (('CP866','CP1251'),'CP866'),
)

def decode(x,path=()) :
    for f,t in path[0:-1] :
        x = x.decode(f).encode(t,'ignore')
    return x.decode(path[-1])

def ifret(cond,s1,s2) :
    if cond :
        return s1
    else :
        return s2

def check_decode(str,to=default_target_encoding) :
    debug(time.time())
    debug('Start %s' % str )
    test = reduce(lambda x,y : ifret(len(x)>len(y),x,y),srch.findall(str),'')
    debug(test)
    test = test[0:min(len(test),64)]
    if len(test) > 5 :
        return recode(str,test,to=default_target_encoding)
    return str

def recode(x,test,to=default_target_encoding) :
        count = ngramcount(test)
        code  = None

        for item in encode_paths :
                dec = decode(test,item).lower()
                c = ngramcount(dec)
                debug( "%u,%u -- %-40s : %s" % (c,count,item,dec.encode(default_target_encoding,'ignore') ))
                if c > count :
                        count = c
                        code  = item
                        debug("Set into %s" % str(code))

        debug(time.time())
        if code :
                debug('Decoding....')
                return decode(x,code).encode(to,'ignore')

        return x

def ngramcount(string) :
        query = []
        count = 0
        for ch in list(string) :
                query = query[-2:]
                query.append(ch)
                count = count + ngramcheck(query[0:])
                count = count + ngramcheck(query[1:])
                count = count + ngramcheck(query[2:])
        return count

def ngramcheck(lst) :
        try :
                return sample[string.join(lst,'')]
        except KeyError :
                return 0

if __name__ == '__main__' :
        import getopt
        import sys
        
        opts,args = getopt.getopt(sys.argv[1:],"mvht:f:")
        delim = '\012'
        trt = None
#        decode_debug = 0
        for a,v in  opts :
                if a == '-h' :
                        print __doc__ 
                        sys.exit(0)
                elif a == '-v' :
                        decode_debug = 1
                elif a == '-m' :
                        delim = '\015\012'
                elif a == '-f' :
                        print 'Not Implemented'
                        sys.exit(0)
                elif a == '-t' :
                        default_target_encoding = v

        text = sys.stdin.read()
        text = re.sub(re.compile('\015*\012\015*|\012*\015\012*'),delim,text)
        print text
        text = check_decode(text,to=default_target_encoding)
        # if trt : text = string.translate(text,trt)
        print text
