__doc__ = """\
Project:RequestDecoder
Start:  Tue Dec 18 12:38:16 MSK 2001
Author: Andrey Orlovr(c) 2001
Version:$Id: uncensored.py,v 1.8 2003/01/12 16:36:01 cray Exp $

Title:       ""

Description:
              
           ,   
               .

        select  -     ,   Zope;

        words -  ;

        search_fast -   ,    
                 ;

        search_long_in -   ,   (
                min_word_size),     ;

        search_fuzzy -       ,  
                .      
                min_word_size;

Features: 
        Running in console mode is possible. Command line in this case
        must be the dictionary name.

License :
        GPL
    
Warranty:
        There is no warranty of any kind, either expressed or implied
"""
__version__ = '$Revision: 1.8 $'[8:-1]

import re
import os
import string
import locale
import codecs

if __name__ == '__main__' :
        locale.setlocale(0,os.environ.get('LC_ALL',os.environ.get('LC_CTYPE','ru_RU.KOI8-R')))

SOURCE_ENCODINGS = 'koi8-r'
default_target_encoding = locale.getlocale()[1]

try:
    codecs.lookup(default_target_encoding)
except (LookupError, SystemError):
    pass

def enc(s) :
    return s.decode(SOURCE_ENCODINGS).encode(default_target_encoding)

min_word_size = 5 

words = """       գ
 xy xyu x y       
        
   ģ     
       գ 
      գ գ
 գ         
         
         
x y xy x y """

words = words + """      
         
    
     
    
    
    
     
   
   
"""

words_list = string.split(words)
dots = '[.,:;"!?_\s]'
#dots = '[.,:;"!?_ ]'
flags = re.I|re.M|re.L

regexp_fast = '(^|' + dots + ')(' + string.join(words_list,'|') + ')(' + dots + '|$)'
search_fast = re.compile(enc(regexp_fast),re.M).search

words_short = filter(lambda x,m=min_word_size : len(x)<m, words_list)
words_long  = filter(lambda x,m=min_word_size : len(x)>=m, words_list)

regexp_long_in = '((^|' + dots + ')(' + string.join(words_short,'|') + ')(' + dots + '|$))|' \
                 '((^|' + dots + ')[^\s]*(' + string.join(words_long,'|') + ')[^\s]*(' + dots + '|$))'

search_long_in = re.compile(enc(regexp_long_in),re.M).search

pairs = ('ʣ','','','','')
subst = {
        '':'(|)',
        '':'(|)',
        '':'(|)',
}

for ss in pairs :
        for c in ss :
                subst[c]='[%s]' % ss    

def compile(w) :
        return re.sub("(%s)" % string.join(subst.keys(),'|'),lambda x,d=subst: d[x.group()], w)

words_long      = map(compile,words_long)
regexp_fuzzy = '((^|' + dots + ')(' + string.join(words_short,'|') + ')(' + dots + '|$))|' \
                 '((^|' + dots + ')([^\s]*(' + string.join(words_long,'|') + ')[^\s]*)(' + dots + '|$))'
search_fuzzy = re.compile(enc(regexp_fuzzy),re.M).search

wrs = string.split("[y][ţ]  [][]?    []?   ")
affx = string.split( """                   ?
   
 ? ?           [] []
 []                       
                         
 [] [] []   """)
prefx = string.split("              ")

#wrs = map(compile,wrs)
#affx = map(compile,affx)
#prefx = map(compile,prefx)

regexp_affix = '(^|' + dots + ')((' + string.join(prefx,'|')+ '){0,2}(' + string.join(wrs,'|')+ ')(' + string.join(affx,'|')+ '){0,3}){1,2}(' + dots + '|$)'
search_affix = re.compile(enc(regexp_affix),flags).search

censors = {
        'Crazy':search_fuzzy,
        'Strong':search_long_in,
        'Affix':search_affix,
        'Fast':search_fast
}

censor_list = censors.keys()

if __name__ == '__main__' :
        import sys
        
        try :
                check = censors[sys.argv[1]]
        except KeyError :
                print "Unknown censor"
                sys.exit()
        except IndexError :
                print "Censor not selected, search_fast will be used"
                check = search_fast

        print check,dir(check)
        print 'Regular expression', check.__self__.pattern

        try :
                while 1 :
                        item = raw_input('...>  ')
                        res = check(item)
                        if res :
                                print 'Nasty:', '"%s"' % res.group(0)
                        else :
                                print 'Clean:',item
        except EOFError :
                print 'EOF'       
